# -*- coding: utf-8 -*-
#Библиотеки, които използват python и Kodi в тази приставка
import re
import sys
import os
import urllib
import urllib2
import HTMLParser
import xbmc
import xbmcgui
import xbmcplugin
import xbmcaddon
import urlresolver

#Място за дефиниране на константи, които ще се използват няколкократно из отделните модули
__addon_id__= 'plugin.video.anibg'
__Addon = xbmcaddon.Addon(__addon_id__)
searchicon = xbmc.translatePath(__Addon.getAddonInfo('path') + "/resources/search.png")
UA = 'Mozilla%2F5.0+%28X11%3B+Ubuntu%3B+Linux+x86_64%3B+rv%3A42.0%29+Gecko%2F20100101+Firefox%2F42.0' #За симулиране на заявка от компютърен браузър


#Меню с директории в приставката
def CATEGORIES():
        addDir('Търсене','http://anibg.info/search/',3,searchicon)
        addDir('Топли-топли','http://anibg.info/more/new-anime/page-1.html',1,'DefaultFolder.png')
        addDir('Екшън','http://anibg.info/category/%D0%95%D0%BA%D1%88%D1%8A%D0%BD_25/page-1.html',1,'DefaultFolder.png')
        addDir('Приключенски','http://anibg.info/category/%D0%9F%D1%80%D0%B8%D0%BA%D0%BB%D1%8E%D1%87%D0%B5%D0%BD%D1%81%D0%BA%D0%B8_24/page-1.html',1,'DefaultFolder.png')
        addDir('Коли','http://anibg.info/category/%D0%9A%D0%BE%D0%BB%D0%B8_23/page-1.html',1,'DefaultFolder.png')
        addDir('Комедия','http://anibg.info/category/%D0%9A%D0%BE%D0%BC%D0%B5%D0%B4%D0%B8%D1%8F_7/page-1.html',1,'DefaultFolder.png')
        addDir('Демони','http://anibg.info/category/%D0%94%D0%B5%D0%BC%D0%BE%D0%BD%D0%B8_9/page-1.html',1,'DefaultFolder.png')
        addDir('Драма','http://anibg.info/category/%D0%94%D1%80%D0%B0%D0%BC%D0%B0_10/page-1.html',1,'DefaultFolder.png')
        addDir('Ечи','http://anibg.info/category/%D0%95%D1%87%D0%B8_11/page-1.html',1,'DefaultFolder.png')
        addDir('Фантазия','http://anibg.info/category/%D0%A4%D0%B0%D0%BD%D1%82%D0%B0%D0%B7%D0%B8%D1%8F_12/page-1.html',1,'DefaultFolder.png')
        addDir('Игри','http://anibg.info/category/%D0%98%D0%B3%D1%80%D0%B8_13/page-1.html',1,'DefaultFolder.png')
        addDir('Харем','http://anibg.info/category/%D0%A5%D0%B0%D1%80%D0%B5%D0%BC_14/page-1.html',1,'DefaultFolder.png')
        addDir('Исторически','http://anibg.info/category/%D0%98%D1%81%D1%82%D0%BE%D1%80%D0%B8%D1%87%D0%B5%D1%81%D0%BA%D0%B8_15/page-1.html',1,'DefaultFolder.png')
        addDir('Ужаси','http://anibg.info/category/%D0%A3%D0%B6%D0%B0%D1%81%D0%B8_16/page-1.html',1,'DefaultFolder.png')
        addDir('Джосей','http://anibg.info/category/%D0%94%D0%B6%D0%BE%D1%81%D0%B5%D0%B9_17/page-1.html',1,'DefaultFolder.png')
        addDir('Деца','http://anibg.info/category/%D0%94%D0%B5%D1%86%D0%B0_18/page-1.html',1,'DefaultFolder.png')
        addDir('Магия','http://anibg.info/category/%D0%9C%D0%B0%D0%B3%D0%B8%D1%8F_19/page-1.html',1,'DefaultFolder.png')
        addDir('Бойни изкуства','http://anibg.info/category/%D0%91%D0%BE%D0%B9%D0%BD%D0%B8-%D0%B8%D0%B7%D0%BA%D1%83%D1%81%D1%82%D0%B2%D0%B0_20/page-1.html',1,'DefaultFolder.png')
        addDir('Меха','http://anibg.info/category/%D0%9C%D0%B5%D1%85%D0%B0_21/page-1.html',1,'DefaultFolder.png')
        addDir('Военни','http://anibg.info/category/%D0%92%D0%BE%D0%B5%D0%BD%D0%BD%D0%B8_26/page-1.html',1,'DefaultFolder.png')
        addDir('Музикални','http://anibg.info/category/%D0%9C%D1%83%D0%B7%D0%B8%D0%BA%D0%B0%D0%BB%D0%BD%D0%B8_28/page-1.html',1,'DefaultFolder.png')
        addDir('Мистерия','http://anibg.info/category/%D0%9C%D0%B8%D1%81%D1%82%D0%B5%D1%80%D0%B8%D1%8F_29/page-1.html',1,'DefaultFolder.png')
        addDir('Пародия','http://anibg.info/category/%D0%9F%D0%B0%D1%80%D0%BE%D0%B4%D0%B8%D1%8F_30/page-1.html',1,'DefaultFolder.png')
        addDir('Полиция','http://anibg.info/category/%D0%9F%D0%BE%D0%BB%D0%B8%D1%86%D0%B8%D1%8F_31/page-1.html',1,'DefaultFolder.png')
        addDir('Психологически','http://anibg.info/category/%D0%9F%D1%81%D0%B8%D1%85%D0%BE%D0%BB%D0%BE%D0%B3%D0%B8%D1%87%D0%B5%D1%81%D0%BA%D0%B8_32/page-1.html',1,'DefaultFolder.png')
        addDir('Романтика','http://anibg.info/category/%D0%A0%D0%BE%D0%BC%D0%B0%D0%BD%D1%82%D0%B8%D0%BA%D0%B0_33/page-1.html',1,'DefaultFolder.png')
        addDir('Самурай','http://anibg.info/category/%D0%A1%D0%B0%D0%BC%D1%83%D1%80%D0%B0%D0%B9_34/page-1.html',1,'DefaultFolder.png')
        addDir('Училище','http://anibg.info/category/%D0%A3%D1%87%D0%B8%D0%BB%D0%B8%D1%89%D0%B5_35/page-1.html',1,'DefaultFolder.png')
        addDir('Sci-Fi','http://anibg.info/category/scifi_36/page-1.html',1,'DefaultFolder.png')
        addDir('Сейнен','http://anibg.info/category/%D0%A1%D0%B5%D0%B9%D0%BD%D0%B5%D0%BD_37/page-1.html',1,'DefaultFolder.png')
        addDir('Шоуджо','http://anibg.info/category/%D0%A8%D0%BE%D1%83%D0%B4%D0%B6%D0%BE_38/page-1.html',1,'DefaultFolder.png')
        addDir('Шоуджо Ай','http://anibg.info/category/%D0%A8%D0%BE%D1%83%D0%B4%D0%B6%D0%BE-%D0%90%D0%B9_39/page-1.html',1,'DefaultFolder.png')
        addDir('Шоунен','http://anibg.info/category/%D0%A8%D0%BE%D1%83%D0%BD%D0%B5%D0%BD_40/page-1.html',1,'DefaultFolder.png')
        addDir('Шоунен Ай','http://anibg.info/category/%D0%A8%D0%BE%D1%83%D0%BD%D0%B5%D0%BD-%D0%90%D0%B9_41/page-1.html',1,'DefaultFolder.png')
        addDir('Космос','http://anibg.info/category/%D0%9A%D0%BE%D1%81%D0%BC%D0%BE%D1%81_42/page-1.html',1,'DefaultFolder.png')
        addDir('Спорт','http://anibg.info/category/%D0%A1%D0%BF%D0%BE%D1%80%D1%82_43/page-1.html',1,'DefaultFolder.png')
        addDir('Супер сили','http://anibg.info/category/%D0%A1%D1%83%D0%BF%D0%B5%D1%80-%D1%81%D0%B8%D0%BB%D0%B8_44/page-1.html',1,'DefaultFolder.png')
        addDir('Свръхестествено','http://anibg.info/category/%D0%A1%D0%B2%D1%80%D1%8A%D1%85%D0%B5%D1%81%D1%82%D0%B5%D1%81%D1%82%D0%B2%D0%B5%D0%BD%D0%BE_45/page-1.html',1,'DefaultFolder.png')
        addDir('Трилър','http://anibg.info/category/%D0%A2%D1%80%D0%B8%D0%BB%D1%8A%D1%80_46/page-1.html',1,'DefaultFolder.png')
        addDir('Вампири','http://anibg.info/category/%D0%92%D0%B0%D0%BC%D0%BF%D0%B8%D1%80%D0%B8_47/page-1.html',1,'DefaultFolder.png')
        addDir('Яой','http://anibg.info/category/%D0%AF%D0%BE%D0%B9_48/page-1.html',1,'DefaultFolder.png')
        addDir('Юри','http://anibg.info/category/%D0%AE%D1%80%D0%B8_49/page-1.html',1,'DefaultFolder.png')
        addDir('16+','http://anibg.info/category/16*plus_50/page-1.html',1,'DefaultFolder.png')
        addDir('С български дублаж','http://anibg.info/lang/%D0%94%D1%83%D0%B1%D0%BB%D0%B8%D1%80%D0%B0%D0%BD_3/page-1.html',1,'DefaultFolder.png')
        addDir('С български субтитри','http://anibg.info/lang/%D0%91%D1%8A%D0%BB%D0%B3%D0%B0%D1%80%D1%81%D0%BA%D0%B8_1/page-1.html',1,'DefaultFolder.png')
        addDir('С английски субтитри','http://anibg.info/lang/%D0%90%D0%BD%D0%B3%D0%BB%D0%B8%D0%B9%D1%81%D0%BA%D0%B8_2/page-1.html',1,'DefaultFolder.png')
        #addDir('','',1,'')




#Разлистване на категориите аниме
def INDEXCAT(url):
        req = urllib2.Request(url)
        req.add_header('User-Agent', UA)
        response = urllib2.urlopen(req)
        #print 'request page url:' + url
        data=response.read()
        response.close()
        
        #Начало на обхождането
        br = 0 #Брояч на аниметата в страницата
        match = re.compile('<div class="item">\n.*<a href="(.+?)" title="(.+?)">\n.*<img src="(.+?)"').findall(data)
        for alink, title, poster in match:
            poster = 'http://anibg.info/' + poster.replace(' ','%20')
            addDir(title,alink,2,poster)
            br = br + 1 #добавяме и това видео към общия брояч
        #Край на обхождането
        
        #Ако резултатите са на повече от една страници
        if br == 24: #тогава имаме следваща страница и конструираме нейния адрес
            getpage=re.compile('(.+?)page-(.+?).html').findall(url)
            for baseurl,page in getpage:
                newpage = int(page)+1
                url = baseurl + 'page-' + str(newpage) + '.html'
                #print 'URL OF THE NEXT PAGE IS:' + url
                thumbnail='DefaultFolder.png'
                addDir('следваща страница>>',url,1,thumbnail)






#Обложка и -описание- на дадено аниме
def INDEXPAGES(url):
        req = urllib2.Request(url)
        req.add_header('User-Agent', UA)
        response = urllib2.urlopen(req)
        #print 'request page url:' + url
        data=response.read()
        response.close()
        
        
        #Извличане на обложката и заглавието (отново)
        matchp = re.compile('<img src="(.+?)" alt="(.+?) -.*style=').findall(data)
        for poster, title in matchp:
            poster = 'http://anibg.info/' + poster.replace(' ','%20')
        
            #Откриване на youtube трейлър
            matcht = re.compile('<iframe width=.* height=.* src="(.+?)" frameborder=.*</iframe>').findall(data)
            for tlink in matcht:
                tlink = tlink.replace('?rel=0&amp;wmode=transparent','')
                addLink('Трейлър',tlink,4,poster)
        
            #Намиране линка към епизодите
            matche = re.compile('<a href="(http.+?)" title=".*">Гледай</a>').findall(data)
            for elink in matche:
                req = urllib2.Request(elink)
                req.add_header('User-Agent', UA)
                response = urllib2.urlopen(req)
                #print 'request page url:' + url
                data2=response.read()
                response.close()
           
                #Извличане на линкове към епизодите и номерацията им
                matchi = re.compile('<a href="(.+?)" class="ep..(.+?)</a>').findall(data2)
                for link, nomer in matchi:
                    nomer = nomer.replace('elec"><b>','') #Зачистване на епизод 1
                    nomer = nomer.replace('</b>','') #Зачистване на епизод 1
                    link = 'http://anibg.info/' + link
                    epizod = name + ' Епизод ' + str(nomer)
                    addLink(epizod,link,4,poster)
                VBOX7('проверете за алтернативен линк за гледане във VBOX7',poster)
                KISSANIME('проверете за алтернативен линк за гледане в KissAnime',poster)






#Търсачка
def SEARCH(url):
        keyb = xbmc.Keyboard('', 'Търсачка')
        keyb.doModal()
        searchText = ''
        if (keyb.isConfirmed()):
            searchText = urllib.quote_plus(keyb.getText())
            searchText=searchText.replace(' ','+')
            searchurl = url + searchText + '/page-1.html'
            searchurl = searchurl.encode('utf-8')
            print 'SEARCHING:' + searchurl
            INDEXCAT(searchurl)
        else:
            addDir('Върнете се назад в главното меню за да продължите','','',"DefaultFolderBack.png")







#Подготвяне и зареждане на видео
def PLAY(name,url,iconimage):
        
        if "youtu" in url: #Поддръжка на youtube трейлъри
            #print 'Имаме youtube trailer'
            url = url.replace('http://www.youtube.com/embed/','')
            url = url.replace('https://www.youtube.com/embed/','')
            ok=True
            pipeurl = "plugin://plugin.video.youtube/play/?video_id=" + url
            #print 'ANIBG: Пренасочване към ' + pipeurl
            item = xbmcgui.ListItem(path=pipeurl, iconImage=iconimage, thumbnailImage=iconimage)
            xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)
            return ok

        req = urllib2.Request(url)
        req.add_header('User-Agent', UA)
        response = urllib2.urlopen(req)
        #print 'request page url:' + url
        data=response.read()
        response.close()

        #Извличане на линка към видео хостинга
        match = re.compile('"proxy.link": "(.+?)"').findall(data)
        for hlink in match:
            print 'ANIBG: Video is hosted on ' + hlink
            try:
                if "vbox7" in hlink: #Поддръжка на vbox7
                    hlink = hlink.replace('http://vbox7.com/play:','')
                    ok=True
                    pipeurl = "plugin://plugin.video.vbox7/?url=" + hlink + '&mode=2&name=' + name
                    #print 'ANIBG: Пренасочване към ' + pipeurl
                    item = xbmcgui.ListItem(path=pipeurl, iconImage=iconimage, thumbnailImage=iconimage)
                    xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)
                    return ok
                
                if "youtu" in hlink: #Поддръжка на youtube
                    hlink = hlink.replace('http://www.youtube.com/embed/','')
                    hlink = hlink.replace('https://www.youtube.com/embed/','')
                    #print 'hlink ' + hlink
                    ok=True
                    pipeurl = "plugin://plugin.video.youtube/play/?video_id=" + hlink
                    #print 'ANIBG: Пренасочване към ' + pipeurl
                    item = xbmcgui.ListItem(path=pipeurl, iconImage=iconimage, thumbnailImage=iconimage)
                    xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)
                    return ok
                
                
                if "kissanime" in hlink: #Не се поддържат линкове към kissanime
                    ok=True
                    item = xbmcgui.ListItem(path=xbmc.translatePath(__Addon.getAddonInfo('path') + "/resources/kissanime.mp3"), iconImage=iconimage, thumbnailImage=iconimage)
                    xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)
                    dialog = xbmcgui.Dialog()
                    dialog.ok(" Мару чан, имаме проблем...", "Това видео е хостнато в kissanime.to. В момента не поддържаме директно отваряне на техни видеа, но можете да използвате линка най-отдолу за стартиране на Kodi приставката plugin.video.kissanime :(")
                    return ok
                    
                
                if "ok.ru" in hlink: #Поддръжка на odnoklassniki.ru - https://github.com/uscclarkey/repo/blob/master/plugin.video.genesis/commonresolvers.py
                    hlink = hlink.replace('http://ok.ru/video/','')
                    ok=True
                    hlink = 'http://www.odnoklassniki.ru/dk?cmd=videoPlayerMetadata&mid=' + hlink
                    #print 'hlink ' + hlink
                    pars = HTMLParser.HTMLParser()
                    req = urllib2.Request(hlink)
                    req.add_header('User-Agent', UA)
                    response = urllib2.urlopen(req)
                    result=response.read()
                    response.close()
                    result = pars.unescape(result).decode('unicode_escape', 'ignore').encode('utf-8', 'ignore')
                    #print 'result '  +result
                    matchok = re.compile('"name":"low","url":"(.+?)"').findall(result)
                    for oklink in matchok:
                        item = xbmcgui.ListItem(path=oklink, iconImage=iconimage, thumbnailImage=iconimage)
                        xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)
                    
                    
                    
                if "picasa" in hlink: #Поддръжка на picasaweb.google.com
                    ok=True
                    req = urllib2.Request(hlink)
                    req.add_header('User-Agent', UA)
                    response = urllib2.urlopen(req)
                    result=response.read()
                    response.close()
                    matchg = re.compile(',{"url":"(.+?)","height":\d+,"width":\d+,"type":"video/mpeg4"}').findall(result)
                    for glink in matchg:
                        item = xbmcgui.ListItem(path=glink+'|User-Agent='+UA, iconImage=iconimage, thumbnailImage=iconimage)
                        xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)
                    
                    
                
                
                hmf = urlresolver.HostedMediaFile(hlink) #Play via universal urlresolver
                if hmf:
                    pipeurl = urlresolver.resolve(hlink)
                    item = xbmcgui.ListItem(path=str(pipeurl), iconImage=iconimage, thumbnailImage=iconimage)
                    xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)
                
                
                
            except:
                xbmc.executebuiltin("Notification(Грешка,Не се поддържа този хостинг!,9000)")






#Пренасочване към vbox7
def VBOX7(name,iconimage):
        ok=True
        cover='http://pbs.twimg.com/profile_images/644488390621065216/XE1UYr_M.png'
        pipeurl = "plugin://plugin.video.vbox7/"
        item = xbmcgui.ListItem(name, cover, cover)
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=pipeurl,listitem=item,isFolder=True)
        return ok




#Пренасочване към kissanime
def KISSANIME(name,iconimage):
        ok=True
        cover='http://pbs.twimg.com/profile_images/512886674838130688/f3ovdHky_400x400.png'
        pipeurl = "plugin://plugin.video.kissanime/"
        item = xbmcgui.ListItem(name, cover, cover)
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=pipeurl,listitem=item,isFolder=True)
        return ok






#Модул за добавяне на отделно заглавие и неговите атрибути към съдържанието на показваната в Kodi директория - НЯМА НУЖДА ДА ПРОМЕНЯТЕ НИЩО ТУК
def addLink(name,url,mode,iconimage):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)
        ok=True
        liz=xbmcgui.ListItem(name, iconImage=iconimage, thumbnailImage=iconimage)
        liz.setInfo( type="Video", infoLabels={ "Title": name } )
        liz.setProperty("IsPlayable" , "true")
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=False)
        return ok

#Модул за добавяне на отделна директория и нейните атрибути към съдържанието на показваната в Kodi директория - НЯМА НУЖДА ДА ПРОМЕНЯТЕ НИЩО ТУК
def addDir(name,url,mode,iconimage):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)
        ok=True
        liz=xbmcgui.ListItem(name, iconImage=iconimage, thumbnailImage=iconimage)
        liz.setInfo( type="Video", infoLabels={ "Title": name } )
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=True)
        return ok


#НЯМА НУЖДА ДА ПРОМЕНЯТЕ НИЩО ТУК
def get_params():
        param=[]
        paramstring=sys.argv[2]
        if len(paramstring)>=2:
                params=sys.argv[2]
                cleanedparams=params.replace('?','')
                if (params[len(params)-1]=='/'):
                        params=params[0:len(params)-2]
                pairsofparams=cleanedparams.split('&')
                param={}
                for i in range(len(pairsofparams)):
                        splitparams={}
                        splitparams=pairsofparams[i].split('=')
                        if (len(splitparams))==2:
                                param[splitparams[0]]=splitparams[1]
                                
        return param



params=get_params()
url=None
name=None
iconimage=None
mode=None

try:
        url=urllib.unquote_plus(params["url"])
except:
        pass
try:
        name=urllib.unquote_plus(params["name"])
except:
        pass
try:
        name=urllib.unquote_plus(params["iconimage"])
except:
        pass
try:
        mode=int(params["mode"])
except:
        pass


#Списък на отделните подпрограми/модули в тази приставка - трябва напълно да отговаря на кода отгоре
if mode==None or url==None or len(url)<1:
        print ""
        CATEGORIES()
    
elif mode==1:
        print ""+url
        INDEXCAT(url)

elif mode==2:
        print ""+url
        INDEXPAGES(url)

elif mode==3:
        print ""+url
        SEARCH(url)

elif mode==4:
        print ""+url
        PLAY(name,url,iconimage)

elif mode==5:
        print ""+url
        VBOX7(name,iconimage)

elif mode==6:
        print ""+url
        KISSANIME(name,iconimage)


xbmcplugin.endOfDirectory(int(sys.argv[1]))